/*
Authorization Service API v. 1.0

<a href='https://cern.service-now.com/service-portal?id=privacy_policy&se=SSO-Service&notice=resources'>Privacy notice</a>

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package authzapiv1

import (
	"bytes"
	"encoding/json"
	"fmt"
	"time"
)

// checks if the Application type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &Application{}

// Application struct for Application
type Application struct {
	ApplicationIdentifier NullableString       `json:"applicationIdentifier,omitempty"`
	DisplayName           string               `json:"displayName"`
	IdentityId            NullableString       `json:"identityId,omitempty"`
	Description           NullableString       `json:"description,omitempty"`
	AdministratorsId      NullableString       `json:"administratorsId,omitempty"`
	ManagerId             NullableString       `json:"managerId,omitempty"`
	AdministratorsAccess  AdministratorsAccess `json:"administratorsAccess"`
	HomePage              NullableString       `json:"homePage,omitempty"`
	ResourceCategory      *ResourceCategory    `json:"resourceCategory,omitempty"`
	Reassignable          *bool                `json:"reassignable,omitempty"`
	AutoReassign          *bool                `json:"autoReassign,omitempty"`
	// Deprecated
	PendingAction    *bool          `json:"pendingAction,omitempty"`
	Disabled         *bool          `json:"disabled,omitempty"`
	Blocked          *bool          `json:"blocked,omitempty"`
	SecurityIssues   *bool          `json:"securityIssues,omitempty"`
	BlockingReason   NullableString `json:"blockingReason,omitempty"`
	BlockingTime     NullableTime   `json:"blockingTime,omitempty"`
	BlockingDeadline NullableTime   `json:"blockingDeadline,omitempty"`
	ArchiveDeadline  NullableTime   `json:"archiveDeadline,omitempty"`
	DeleteDeadline   NullableTime   `json:"deleteDeadline,omitempty"`
	// Deprecated
	ExpirationDeadline  NullableTime   `json:"expirationDeadline,omitempty"`
	OwnerId             NullableString `json:"ownerId,omitempty"`
	InternalState       *ResourceState `json:"internalState,omitempty"`
	State               *ResourceState `json:"state,omitempty"`
	LastStateChangeTime NullableTime   `json:"lastStateChangeTime,omitempty"`
	ValidityLimit       NullableTime   `json:"validityLimit,omitempty"`
	Id                  NullableString `json:"id,omitempty"`
	CreationTime        *time.Time     `json:"creationTime,omitempty"`
}

type _Application Application

// NewApplication instantiates a new Application object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewApplication(displayName string, administratorsAccess AdministratorsAccess) *Application {
	this := Application{}
	this.DisplayName = displayName
	this.AdministratorsAccess = administratorsAccess
	return &this
}

// NewApplicationWithDefaults instantiates a new Application object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewApplicationWithDefaults() *Application {
	this := Application{}
	return &this
}

// GetApplicationIdentifier returns the ApplicationIdentifier field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Application) GetApplicationIdentifier() string {
	if o == nil || IsNil(o.ApplicationIdentifier.Get()) {
		var ret string
		return ret
	}
	return *o.ApplicationIdentifier.Get()
}

// GetApplicationIdentifierOk returns a tuple with the ApplicationIdentifier field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Application) GetApplicationIdentifierOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.ApplicationIdentifier.Get(), o.ApplicationIdentifier.IsSet()
}

// HasApplicationIdentifier returns a boolean if a field has been set.
func (o *Application) HasApplicationIdentifier() bool {
	if o != nil && o.ApplicationIdentifier.IsSet() {
		return true
	}

	return false
}

// SetApplicationIdentifier gets a reference to the given NullableString and assigns it to the ApplicationIdentifier field.
func (o *Application) SetApplicationIdentifier(v string) {
	o.ApplicationIdentifier.Set(&v)
}

// SetApplicationIdentifierNil sets the value for ApplicationIdentifier to be an explicit nil
func (o *Application) SetApplicationIdentifierNil() {
	o.ApplicationIdentifier.Set(nil)
}

// UnsetApplicationIdentifier ensures that no value is present for ApplicationIdentifier, not even an explicit nil
func (o *Application) UnsetApplicationIdentifier() {
	o.ApplicationIdentifier.Unset()
}

// GetDisplayName returns the DisplayName field value
func (o *Application) GetDisplayName() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.DisplayName
}

// GetDisplayNameOk returns a tuple with the DisplayName field value
// and a boolean to check if the value has been set.
func (o *Application) GetDisplayNameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.DisplayName, true
}

// SetDisplayName sets field value
func (o *Application) SetDisplayName(v string) {
	o.DisplayName = v
}

// GetIdentityId returns the IdentityId field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Application) GetIdentityId() string {
	if o == nil || IsNil(o.IdentityId.Get()) {
		var ret string
		return ret
	}
	return *o.IdentityId.Get()
}

// GetIdentityIdOk returns a tuple with the IdentityId field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Application) GetIdentityIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.IdentityId.Get(), o.IdentityId.IsSet()
}

// HasIdentityId returns a boolean if a field has been set.
func (o *Application) HasIdentityId() bool {
	if o != nil && o.IdentityId.IsSet() {
		return true
	}

	return false
}

// SetIdentityId gets a reference to the given NullableString and assigns it to the IdentityId field.
func (o *Application) SetIdentityId(v string) {
	o.IdentityId.Set(&v)
}

// SetIdentityIdNil sets the value for IdentityId to be an explicit nil
func (o *Application) SetIdentityIdNil() {
	o.IdentityId.Set(nil)
}

// UnsetIdentityId ensures that no value is present for IdentityId, not even an explicit nil
func (o *Application) UnsetIdentityId() {
	o.IdentityId.Unset()
}

// GetDescription returns the Description field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Application) GetDescription() string {
	if o == nil || IsNil(o.Description.Get()) {
		var ret string
		return ret
	}
	return *o.Description.Get()
}

// GetDescriptionOk returns a tuple with the Description field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Application) GetDescriptionOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Description.Get(), o.Description.IsSet()
}

// HasDescription returns a boolean if a field has been set.
func (o *Application) HasDescription() bool {
	if o != nil && o.Description.IsSet() {
		return true
	}

	return false
}

// SetDescription gets a reference to the given NullableString and assigns it to the Description field.
func (o *Application) SetDescription(v string) {
	o.Description.Set(&v)
}

// SetDescriptionNil sets the value for Description to be an explicit nil
func (o *Application) SetDescriptionNil() {
	o.Description.Set(nil)
}

// UnsetDescription ensures that no value is present for Description, not even an explicit nil
func (o *Application) UnsetDescription() {
	o.Description.Unset()
}

// GetAdministratorsId returns the AdministratorsId field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Application) GetAdministratorsId() string {
	if o == nil || IsNil(o.AdministratorsId.Get()) {
		var ret string
		return ret
	}
	return *o.AdministratorsId.Get()
}

// GetAdministratorsIdOk returns a tuple with the AdministratorsId field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Application) GetAdministratorsIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.AdministratorsId.Get(), o.AdministratorsId.IsSet()
}

// HasAdministratorsId returns a boolean if a field has been set.
func (o *Application) HasAdministratorsId() bool {
	if o != nil && o.AdministratorsId.IsSet() {
		return true
	}

	return false
}

// SetAdministratorsId gets a reference to the given NullableString and assigns it to the AdministratorsId field.
func (o *Application) SetAdministratorsId(v string) {
	o.AdministratorsId.Set(&v)
}

// SetAdministratorsIdNil sets the value for AdministratorsId to be an explicit nil
func (o *Application) SetAdministratorsIdNil() {
	o.AdministratorsId.Set(nil)
}

// UnsetAdministratorsId ensures that no value is present for AdministratorsId, not even an explicit nil
func (o *Application) UnsetAdministratorsId() {
	o.AdministratorsId.Unset()
}

// GetManagerId returns the ManagerId field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Application) GetManagerId() string {
	if o == nil || IsNil(o.ManagerId.Get()) {
		var ret string
		return ret
	}
	return *o.ManagerId.Get()
}

// GetManagerIdOk returns a tuple with the ManagerId field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Application) GetManagerIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.ManagerId.Get(), o.ManagerId.IsSet()
}

// HasManagerId returns a boolean if a field has been set.
func (o *Application) HasManagerId() bool {
	if o != nil && o.ManagerId.IsSet() {
		return true
	}

	return false
}

// SetManagerId gets a reference to the given NullableString and assigns it to the ManagerId field.
func (o *Application) SetManagerId(v string) {
	o.ManagerId.Set(&v)
}

// SetManagerIdNil sets the value for ManagerId to be an explicit nil
func (o *Application) SetManagerIdNil() {
	o.ManagerId.Set(nil)
}

// UnsetManagerId ensures that no value is present for ManagerId, not even an explicit nil
func (o *Application) UnsetManagerId() {
	o.ManagerId.Unset()
}

// GetAdministratorsAccess returns the AdministratorsAccess field value
func (o *Application) GetAdministratorsAccess() AdministratorsAccess {
	if o == nil {
		var ret AdministratorsAccess
		return ret
	}

	return o.AdministratorsAccess
}

// GetAdministratorsAccessOk returns a tuple with the AdministratorsAccess field value
// and a boolean to check if the value has been set.
func (o *Application) GetAdministratorsAccessOk() (*AdministratorsAccess, bool) {
	if o == nil {
		return nil, false
	}
	return &o.AdministratorsAccess, true
}

// SetAdministratorsAccess sets field value
func (o *Application) SetAdministratorsAccess(v AdministratorsAccess) {
	o.AdministratorsAccess = v
}

// GetHomePage returns the HomePage field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Application) GetHomePage() string {
	if o == nil || IsNil(o.HomePage.Get()) {
		var ret string
		return ret
	}
	return *o.HomePage.Get()
}

// GetHomePageOk returns a tuple with the HomePage field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Application) GetHomePageOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.HomePage.Get(), o.HomePage.IsSet()
}

// HasHomePage returns a boolean if a field has been set.
func (o *Application) HasHomePage() bool {
	if o != nil && o.HomePage.IsSet() {
		return true
	}

	return false
}

// SetHomePage gets a reference to the given NullableString and assigns it to the HomePage field.
func (o *Application) SetHomePage(v string) {
	o.HomePage.Set(&v)
}

// SetHomePageNil sets the value for HomePage to be an explicit nil
func (o *Application) SetHomePageNil() {
	o.HomePage.Set(nil)
}

// UnsetHomePage ensures that no value is present for HomePage, not even an explicit nil
func (o *Application) UnsetHomePage() {
	o.HomePage.Unset()
}

// GetResourceCategory returns the ResourceCategory field value if set, zero value otherwise.
func (o *Application) GetResourceCategory() ResourceCategory {
	if o == nil || IsNil(o.ResourceCategory) {
		var ret ResourceCategory
		return ret
	}
	return *o.ResourceCategory
}

// GetResourceCategoryOk returns a tuple with the ResourceCategory field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Application) GetResourceCategoryOk() (*ResourceCategory, bool) {
	if o == nil || IsNil(o.ResourceCategory) {
		return nil, false
	}
	return o.ResourceCategory, true
}

// HasResourceCategory returns a boolean if a field has been set.
func (o *Application) HasResourceCategory() bool {
	if o != nil && !IsNil(o.ResourceCategory) {
		return true
	}

	return false
}

// SetResourceCategory gets a reference to the given ResourceCategory and assigns it to the ResourceCategory field.
func (o *Application) SetResourceCategory(v ResourceCategory) {
	o.ResourceCategory = &v
}

// GetReassignable returns the Reassignable field value if set, zero value otherwise.
func (o *Application) GetReassignable() bool {
	if o == nil || IsNil(o.Reassignable) {
		var ret bool
		return ret
	}
	return *o.Reassignable
}

// GetReassignableOk returns a tuple with the Reassignable field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Application) GetReassignableOk() (*bool, bool) {
	if o == nil || IsNil(o.Reassignable) {
		return nil, false
	}
	return o.Reassignable, true
}

// HasReassignable returns a boolean if a field has been set.
func (o *Application) HasReassignable() bool {
	if o != nil && !IsNil(o.Reassignable) {
		return true
	}

	return false
}

// SetReassignable gets a reference to the given bool and assigns it to the Reassignable field.
func (o *Application) SetReassignable(v bool) {
	o.Reassignable = &v
}

// GetAutoReassign returns the AutoReassign field value if set, zero value otherwise.
func (o *Application) GetAutoReassign() bool {
	if o == nil || IsNil(o.AutoReassign) {
		var ret bool
		return ret
	}
	return *o.AutoReassign
}

// GetAutoReassignOk returns a tuple with the AutoReassign field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Application) GetAutoReassignOk() (*bool, bool) {
	if o == nil || IsNil(o.AutoReassign) {
		return nil, false
	}
	return o.AutoReassign, true
}

// HasAutoReassign returns a boolean if a field has been set.
func (o *Application) HasAutoReassign() bool {
	if o != nil && !IsNil(o.AutoReassign) {
		return true
	}

	return false
}

// SetAutoReassign gets a reference to the given bool and assigns it to the AutoReassign field.
func (o *Application) SetAutoReassign(v bool) {
	o.AutoReassign = &v
}

// GetPendingAction returns the PendingAction field value if set, zero value otherwise.
// Deprecated
func (o *Application) GetPendingAction() bool {
	if o == nil || IsNil(o.PendingAction) {
		var ret bool
		return ret
	}
	return *o.PendingAction
}

// GetPendingActionOk returns a tuple with the PendingAction field value if set, nil otherwise
// and a boolean to check if the value has been set.
// Deprecated
func (o *Application) GetPendingActionOk() (*bool, bool) {
	if o == nil || IsNil(o.PendingAction) {
		return nil, false
	}
	return o.PendingAction, true
}

// HasPendingAction returns a boolean if a field has been set.
func (o *Application) HasPendingAction() bool {
	if o != nil && !IsNil(o.PendingAction) {
		return true
	}

	return false
}

// SetPendingAction gets a reference to the given bool and assigns it to the PendingAction field.
// Deprecated
func (o *Application) SetPendingAction(v bool) {
	o.PendingAction = &v
}

// GetDisabled returns the Disabled field value if set, zero value otherwise.
func (o *Application) GetDisabled() bool {
	if o == nil || IsNil(o.Disabled) {
		var ret bool
		return ret
	}
	return *o.Disabled
}

// GetDisabledOk returns a tuple with the Disabled field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Application) GetDisabledOk() (*bool, bool) {
	if o == nil || IsNil(o.Disabled) {
		return nil, false
	}
	return o.Disabled, true
}

// HasDisabled returns a boolean if a field has been set.
func (o *Application) HasDisabled() bool {
	if o != nil && !IsNil(o.Disabled) {
		return true
	}

	return false
}

// SetDisabled gets a reference to the given bool and assigns it to the Disabled field.
func (o *Application) SetDisabled(v bool) {
	o.Disabled = &v
}

// GetBlocked returns the Blocked field value if set, zero value otherwise.
func (o *Application) GetBlocked() bool {
	if o == nil || IsNil(o.Blocked) {
		var ret bool
		return ret
	}
	return *o.Blocked
}

// GetBlockedOk returns a tuple with the Blocked field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Application) GetBlockedOk() (*bool, bool) {
	if o == nil || IsNil(o.Blocked) {
		return nil, false
	}
	return o.Blocked, true
}

// HasBlocked returns a boolean if a field has been set.
func (o *Application) HasBlocked() bool {
	if o != nil && !IsNil(o.Blocked) {
		return true
	}

	return false
}

// SetBlocked gets a reference to the given bool and assigns it to the Blocked field.
func (o *Application) SetBlocked(v bool) {
	o.Blocked = &v
}

// GetSecurityIssues returns the SecurityIssues field value if set, zero value otherwise.
func (o *Application) GetSecurityIssues() bool {
	if o == nil || IsNil(o.SecurityIssues) {
		var ret bool
		return ret
	}
	return *o.SecurityIssues
}

// GetSecurityIssuesOk returns a tuple with the SecurityIssues field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Application) GetSecurityIssuesOk() (*bool, bool) {
	if o == nil || IsNil(o.SecurityIssues) {
		return nil, false
	}
	return o.SecurityIssues, true
}

// HasSecurityIssues returns a boolean if a field has been set.
func (o *Application) HasSecurityIssues() bool {
	if o != nil && !IsNil(o.SecurityIssues) {
		return true
	}

	return false
}

// SetSecurityIssues gets a reference to the given bool and assigns it to the SecurityIssues field.
func (o *Application) SetSecurityIssues(v bool) {
	o.SecurityIssues = &v
}

// GetBlockingReason returns the BlockingReason field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Application) GetBlockingReason() string {
	if o == nil || IsNil(o.BlockingReason.Get()) {
		var ret string
		return ret
	}
	return *o.BlockingReason.Get()
}

// GetBlockingReasonOk returns a tuple with the BlockingReason field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Application) GetBlockingReasonOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.BlockingReason.Get(), o.BlockingReason.IsSet()
}

// HasBlockingReason returns a boolean if a field has been set.
func (o *Application) HasBlockingReason() bool {
	if o != nil && o.BlockingReason.IsSet() {
		return true
	}

	return false
}

// SetBlockingReason gets a reference to the given NullableString and assigns it to the BlockingReason field.
func (o *Application) SetBlockingReason(v string) {
	o.BlockingReason.Set(&v)
}

// SetBlockingReasonNil sets the value for BlockingReason to be an explicit nil
func (o *Application) SetBlockingReasonNil() {
	o.BlockingReason.Set(nil)
}

// UnsetBlockingReason ensures that no value is present for BlockingReason, not even an explicit nil
func (o *Application) UnsetBlockingReason() {
	o.BlockingReason.Unset()
}

// GetBlockingTime returns the BlockingTime field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Application) GetBlockingTime() time.Time {
	if o == nil || IsNil(o.BlockingTime.Get()) {
		var ret time.Time
		return ret
	}
	return *o.BlockingTime.Get()
}

// GetBlockingTimeOk returns a tuple with the BlockingTime field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Application) GetBlockingTimeOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return o.BlockingTime.Get(), o.BlockingTime.IsSet()
}

// HasBlockingTime returns a boolean if a field has been set.
func (o *Application) HasBlockingTime() bool {
	if o != nil && o.BlockingTime.IsSet() {
		return true
	}

	return false
}

// SetBlockingTime gets a reference to the given NullableTime and assigns it to the BlockingTime field.
func (o *Application) SetBlockingTime(v time.Time) {
	o.BlockingTime.Set(&v)
}

// SetBlockingTimeNil sets the value for BlockingTime to be an explicit nil
func (o *Application) SetBlockingTimeNil() {
	o.BlockingTime.Set(nil)
}

// UnsetBlockingTime ensures that no value is present for BlockingTime, not even an explicit nil
func (o *Application) UnsetBlockingTime() {
	o.BlockingTime.Unset()
}

// GetBlockingDeadline returns the BlockingDeadline field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Application) GetBlockingDeadline() time.Time {
	if o == nil || IsNil(o.BlockingDeadline.Get()) {
		var ret time.Time
		return ret
	}
	return *o.BlockingDeadline.Get()
}

// GetBlockingDeadlineOk returns a tuple with the BlockingDeadline field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Application) GetBlockingDeadlineOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return o.BlockingDeadline.Get(), o.BlockingDeadline.IsSet()
}

// HasBlockingDeadline returns a boolean if a field has been set.
func (o *Application) HasBlockingDeadline() bool {
	if o != nil && o.BlockingDeadline.IsSet() {
		return true
	}

	return false
}

// SetBlockingDeadline gets a reference to the given NullableTime and assigns it to the BlockingDeadline field.
func (o *Application) SetBlockingDeadline(v time.Time) {
	o.BlockingDeadline.Set(&v)
}

// SetBlockingDeadlineNil sets the value for BlockingDeadline to be an explicit nil
func (o *Application) SetBlockingDeadlineNil() {
	o.BlockingDeadline.Set(nil)
}

// UnsetBlockingDeadline ensures that no value is present for BlockingDeadline, not even an explicit nil
func (o *Application) UnsetBlockingDeadline() {
	o.BlockingDeadline.Unset()
}

// GetArchiveDeadline returns the ArchiveDeadline field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Application) GetArchiveDeadline() time.Time {
	if o == nil || IsNil(o.ArchiveDeadline.Get()) {
		var ret time.Time
		return ret
	}
	return *o.ArchiveDeadline.Get()
}

// GetArchiveDeadlineOk returns a tuple with the ArchiveDeadline field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Application) GetArchiveDeadlineOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return o.ArchiveDeadline.Get(), o.ArchiveDeadline.IsSet()
}

// HasArchiveDeadline returns a boolean if a field has been set.
func (o *Application) HasArchiveDeadline() bool {
	if o != nil && o.ArchiveDeadline.IsSet() {
		return true
	}

	return false
}

// SetArchiveDeadline gets a reference to the given NullableTime and assigns it to the ArchiveDeadline field.
func (o *Application) SetArchiveDeadline(v time.Time) {
	o.ArchiveDeadline.Set(&v)
}

// SetArchiveDeadlineNil sets the value for ArchiveDeadline to be an explicit nil
func (o *Application) SetArchiveDeadlineNil() {
	o.ArchiveDeadline.Set(nil)
}

// UnsetArchiveDeadline ensures that no value is present for ArchiveDeadline, not even an explicit nil
func (o *Application) UnsetArchiveDeadline() {
	o.ArchiveDeadline.Unset()
}

// GetDeleteDeadline returns the DeleteDeadline field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Application) GetDeleteDeadline() time.Time {
	if o == nil || IsNil(o.DeleteDeadline.Get()) {
		var ret time.Time
		return ret
	}
	return *o.DeleteDeadline.Get()
}

// GetDeleteDeadlineOk returns a tuple with the DeleteDeadline field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Application) GetDeleteDeadlineOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return o.DeleteDeadline.Get(), o.DeleteDeadline.IsSet()
}

// HasDeleteDeadline returns a boolean if a field has been set.
func (o *Application) HasDeleteDeadline() bool {
	if o != nil && o.DeleteDeadline.IsSet() {
		return true
	}

	return false
}

// SetDeleteDeadline gets a reference to the given NullableTime and assigns it to the DeleteDeadline field.
func (o *Application) SetDeleteDeadline(v time.Time) {
	o.DeleteDeadline.Set(&v)
}

// SetDeleteDeadlineNil sets the value for DeleteDeadline to be an explicit nil
func (o *Application) SetDeleteDeadlineNil() {
	o.DeleteDeadline.Set(nil)
}

// UnsetDeleteDeadline ensures that no value is present for DeleteDeadline, not even an explicit nil
func (o *Application) UnsetDeleteDeadline() {
	o.DeleteDeadline.Unset()
}

// GetExpirationDeadline returns the ExpirationDeadline field value if set, zero value otherwise (both if not set or set to explicit null).
// Deprecated
func (o *Application) GetExpirationDeadline() time.Time {
	if o == nil || IsNil(o.ExpirationDeadline.Get()) {
		var ret time.Time
		return ret
	}
	return *o.ExpirationDeadline.Get()
}

// GetExpirationDeadlineOk returns a tuple with the ExpirationDeadline field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
// Deprecated
func (o *Application) GetExpirationDeadlineOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return o.ExpirationDeadline.Get(), o.ExpirationDeadline.IsSet()
}

// HasExpirationDeadline returns a boolean if a field has been set.
func (o *Application) HasExpirationDeadline() bool {
	if o != nil && o.ExpirationDeadline.IsSet() {
		return true
	}

	return false
}

// SetExpirationDeadline gets a reference to the given NullableTime and assigns it to the ExpirationDeadline field.
// Deprecated
func (o *Application) SetExpirationDeadline(v time.Time) {
	o.ExpirationDeadline.Set(&v)
}

// SetExpirationDeadlineNil sets the value for ExpirationDeadline to be an explicit nil
func (o *Application) SetExpirationDeadlineNil() {
	o.ExpirationDeadline.Set(nil)
}

// UnsetExpirationDeadline ensures that no value is present for ExpirationDeadline, not even an explicit nil
func (o *Application) UnsetExpirationDeadline() {
	o.ExpirationDeadline.Unset()
}

// GetOwnerId returns the OwnerId field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Application) GetOwnerId() string {
	if o == nil || IsNil(o.OwnerId.Get()) {
		var ret string
		return ret
	}
	return *o.OwnerId.Get()
}

// GetOwnerIdOk returns a tuple with the OwnerId field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Application) GetOwnerIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.OwnerId.Get(), o.OwnerId.IsSet()
}

// HasOwnerId returns a boolean if a field has been set.
func (o *Application) HasOwnerId() bool {
	if o != nil && o.OwnerId.IsSet() {
		return true
	}

	return false
}

// SetOwnerId gets a reference to the given NullableString and assigns it to the OwnerId field.
func (o *Application) SetOwnerId(v string) {
	o.OwnerId.Set(&v)
}

// SetOwnerIdNil sets the value for OwnerId to be an explicit nil
func (o *Application) SetOwnerIdNil() {
	o.OwnerId.Set(nil)
}

// UnsetOwnerId ensures that no value is present for OwnerId, not even an explicit nil
func (o *Application) UnsetOwnerId() {
	o.OwnerId.Unset()
}

// GetInternalState returns the InternalState field value if set, zero value otherwise.
func (o *Application) GetInternalState() ResourceState {
	if o == nil || IsNil(o.InternalState) {
		var ret ResourceState
		return ret
	}
	return *o.InternalState
}

// GetInternalStateOk returns a tuple with the InternalState field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Application) GetInternalStateOk() (*ResourceState, bool) {
	if o == nil || IsNil(o.InternalState) {
		return nil, false
	}
	return o.InternalState, true
}

// HasInternalState returns a boolean if a field has been set.
func (o *Application) HasInternalState() bool {
	if o != nil && !IsNil(o.InternalState) {
		return true
	}

	return false
}

// SetInternalState gets a reference to the given ResourceState and assigns it to the InternalState field.
func (o *Application) SetInternalState(v ResourceState) {
	o.InternalState = &v
}

// GetState returns the State field value if set, zero value otherwise.
func (o *Application) GetState() ResourceState {
	if o == nil || IsNil(o.State) {
		var ret ResourceState
		return ret
	}
	return *o.State
}

// GetStateOk returns a tuple with the State field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Application) GetStateOk() (*ResourceState, bool) {
	if o == nil || IsNil(o.State) {
		return nil, false
	}
	return o.State, true
}

// HasState returns a boolean if a field has been set.
func (o *Application) HasState() bool {
	if o != nil && !IsNil(o.State) {
		return true
	}

	return false
}

// SetState gets a reference to the given ResourceState and assigns it to the State field.
func (o *Application) SetState(v ResourceState) {
	o.State = &v
}

// GetLastStateChangeTime returns the LastStateChangeTime field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Application) GetLastStateChangeTime() time.Time {
	if o == nil || IsNil(o.LastStateChangeTime.Get()) {
		var ret time.Time
		return ret
	}
	return *o.LastStateChangeTime.Get()
}

// GetLastStateChangeTimeOk returns a tuple with the LastStateChangeTime field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Application) GetLastStateChangeTimeOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return o.LastStateChangeTime.Get(), o.LastStateChangeTime.IsSet()
}

// HasLastStateChangeTime returns a boolean if a field has been set.
func (o *Application) HasLastStateChangeTime() bool {
	if o != nil && o.LastStateChangeTime.IsSet() {
		return true
	}

	return false
}

// SetLastStateChangeTime gets a reference to the given NullableTime and assigns it to the LastStateChangeTime field.
func (o *Application) SetLastStateChangeTime(v time.Time) {
	o.LastStateChangeTime.Set(&v)
}

// SetLastStateChangeTimeNil sets the value for LastStateChangeTime to be an explicit nil
func (o *Application) SetLastStateChangeTimeNil() {
	o.LastStateChangeTime.Set(nil)
}

// UnsetLastStateChangeTime ensures that no value is present for LastStateChangeTime, not even an explicit nil
func (o *Application) UnsetLastStateChangeTime() {
	o.LastStateChangeTime.Unset()
}

// GetValidityLimit returns the ValidityLimit field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Application) GetValidityLimit() time.Time {
	if o == nil || IsNil(o.ValidityLimit.Get()) {
		var ret time.Time
		return ret
	}
	return *o.ValidityLimit.Get()
}

// GetValidityLimitOk returns a tuple with the ValidityLimit field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Application) GetValidityLimitOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return o.ValidityLimit.Get(), o.ValidityLimit.IsSet()
}

// HasValidityLimit returns a boolean if a field has been set.
func (o *Application) HasValidityLimit() bool {
	if o != nil && o.ValidityLimit.IsSet() {
		return true
	}

	return false
}

// SetValidityLimit gets a reference to the given NullableTime and assigns it to the ValidityLimit field.
func (o *Application) SetValidityLimit(v time.Time) {
	o.ValidityLimit.Set(&v)
}

// SetValidityLimitNil sets the value for ValidityLimit to be an explicit nil
func (o *Application) SetValidityLimitNil() {
	o.ValidityLimit.Set(nil)
}

// UnsetValidityLimit ensures that no value is present for ValidityLimit, not even an explicit nil
func (o *Application) UnsetValidityLimit() {
	o.ValidityLimit.Unset()
}

// GetId returns the Id field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Application) GetId() string {
	if o == nil || IsNil(o.Id.Get()) {
		var ret string
		return ret
	}
	return *o.Id.Get()
}

// GetIdOk returns a tuple with the Id field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Application) GetIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Id.Get(), o.Id.IsSet()
}

// HasId returns a boolean if a field has been set.
func (o *Application) HasId() bool {
	if o != nil && o.Id.IsSet() {
		return true
	}

	return false
}

// SetId gets a reference to the given NullableString and assigns it to the Id field.
func (o *Application) SetId(v string) {
	o.Id.Set(&v)
}

// SetIdNil sets the value for Id to be an explicit nil
func (o *Application) SetIdNil() {
	o.Id.Set(nil)
}

// UnsetId ensures that no value is present for Id, not even an explicit nil
func (o *Application) UnsetId() {
	o.Id.Unset()
}

// GetCreationTime returns the CreationTime field value if set, zero value otherwise.
func (o *Application) GetCreationTime() time.Time {
	if o == nil || IsNil(o.CreationTime) {
		var ret time.Time
		return ret
	}
	return *o.CreationTime
}

// GetCreationTimeOk returns a tuple with the CreationTime field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Application) GetCreationTimeOk() (*time.Time, bool) {
	if o == nil || IsNil(o.CreationTime) {
		return nil, false
	}
	return o.CreationTime, true
}

// HasCreationTime returns a boolean if a field has been set.
func (o *Application) HasCreationTime() bool {
	if o != nil && !IsNil(o.CreationTime) {
		return true
	}

	return false
}

// SetCreationTime gets a reference to the given time.Time and assigns it to the CreationTime field.
func (o *Application) SetCreationTime(v time.Time) {
	o.CreationTime = &v
}

func (o Application) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o Application) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if o.ApplicationIdentifier.IsSet() {
		toSerialize["applicationIdentifier"] = o.ApplicationIdentifier.Get()
	}
	toSerialize["displayName"] = o.DisplayName
	if o.IdentityId.IsSet() {
		toSerialize["identityId"] = o.IdentityId.Get()
	}
	if o.Description.IsSet() {
		toSerialize["description"] = o.Description.Get()
	}
	if o.AdministratorsId.IsSet() {
		toSerialize["administratorsId"] = o.AdministratorsId.Get()
	}
	if o.ManagerId.IsSet() {
		toSerialize["managerId"] = o.ManagerId.Get()
	}
	toSerialize["administratorsAccess"] = o.AdministratorsAccess
	if o.HomePage.IsSet() {
		toSerialize["homePage"] = o.HomePage.Get()
	}
	if !IsNil(o.ResourceCategory) {
		toSerialize["resourceCategory"] = o.ResourceCategory
	}
	if !IsNil(o.Reassignable) {
		toSerialize["reassignable"] = o.Reassignable
	}
	if !IsNil(o.AutoReassign) {
		toSerialize["autoReassign"] = o.AutoReassign
	}
	if !IsNil(o.PendingAction) {
		toSerialize["pendingAction"] = o.PendingAction
	}
	if !IsNil(o.Disabled) {
		toSerialize["disabled"] = o.Disabled
	}
	if !IsNil(o.Blocked) {
		toSerialize["blocked"] = o.Blocked
	}
	if !IsNil(o.SecurityIssues) {
		toSerialize["securityIssues"] = o.SecurityIssues
	}
	if o.BlockingReason.IsSet() {
		toSerialize["blockingReason"] = o.BlockingReason.Get()
	}
	if o.BlockingTime.IsSet() {
		toSerialize["blockingTime"] = o.BlockingTime.Get()
	}
	if o.BlockingDeadline.IsSet() {
		toSerialize["blockingDeadline"] = o.BlockingDeadline.Get()
	}
	if o.ArchiveDeadline.IsSet() {
		toSerialize["archiveDeadline"] = o.ArchiveDeadline.Get()
	}
	if o.DeleteDeadline.IsSet() {
		toSerialize["deleteDeadline"] = o.DeleteDeadline.Get()
	}
	if o.ExpirationDeadline.IsSet() {
		toSerialize["expirationDeadline"] = o.ExpirationDeadline.Get()
	}
	if o.OwnerId.IsSet() {
		toSerialize["ownerId"] = o.OwnerId.Get()
	}
	if !IsNil(o.InternalState) {
		toSerialize["internalState"] = o.InternalState
	}
	if !IsNil(o.State) {
		toSerialize["state"] = o.State
	}
	if o.LastStateChangeTime.IsSet() {
		toSerialize["lastStateChangeTime"] = o.LastStateChangeTime.Get()
	}
	if o.ValidityLimit.IsSet() {
		toSerialize["validityLimit"] = o.ValidityLimit.Get()
	}
	if o.Id.IsSet() {
		toSerialize["id"] = o.Id.Get()
	}
	if !IsNil(o.CreationTime) {
		toSerialize["creationTime"] = o.CreationTime
	}
	return toSerialize, nil
}

func (o *Application) UnmarshalJSON(data []byte) (err error) {
	// This validates that all required properties are included in the JSON object
	// by unmarshalling the object into a generic map with string keys and checking
	// that every required field exists as a key in the generic map.
	requiredProperties := []string{
		"displayName",
		"administratorsAccess",
	}

	allProperties := make(map[string]interface{})

	err = json.Unmarshal(data, &allProperties)

	if err != nil {
		return err
	}

	for _, requiredProperty := range requiredProperties {
		if _, exists := allProperties[requiredProperty]; !exists {
			return fmt.Errorf("no value given for required property %v", requiredProperty)
		}
	}

	varApplication := _Application{}

	decoder := json.NewDecoder(bytes.NewReader(data))
	decoder.DisallowUnknownFields()
	err = decoder.Decode(&varApplication)

	if err != nil {
		return err
	}

	*o = Application(varApplication)

	return err
}

type NullableApplication struct {
	value *Application
	isSet bool
}

func (v NullableApplication) Get() *Application {
	return v.value
}

func (v *NullableApplication) Set(val *Application) {
	v.value = val
	v.isSet = true
}

func (v NullableApplication) IsSet() bool {
	return v.isSet
}

func (v *NullableApplication) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableApplication(val *Application) *NullableApplication {
	return &NullableApplication{value: val, isSet: true}
}

func (v NullableApplication) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableApplication) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
